Crystal Space: iPolygonMesh Struct Reference (Crystal Space Public API Reference)

| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# iPolygonMesh Struct Reference
[Geometry utilities]

This interface reprents a mesh of polygons. More...

`#include <igeom/polymesh.h>`

Inheritance diagram for iPolygonMesh:

[legend]
List of all members.

## Public Member Functions
virtual uint32 | GetChangeNumber () const =0
| When this number changes you know the polygon mesh has changed (deformation has occured) since the last time you got another number from this function.
virtual csFlags & | GetFlags ()=0
| Get flags for this polygon mesh.
virtual int | GetPolygonCount ()=0
| Get the number of polygons for this mesh.
virtual csMeshedPolygon * | GetPolygons ()=0
| Get the pointer to the array of polygons.
virtual int | GetTriangleCount ()=0
| Get the number of triangles for this mesh.
virtual csTriangle * | GetTriangles ()=0
| Get the triangle table for this mesh.
virtual int | GetVertexCount ()=0
| Get the number of vertices for this mesh.
virtual csVector3 * | GetVertices ()=0
| Get the pointer to the array of vertices.
virtual void | Lock ()=0
| Lock the polygon mesh.
virtual void | Unlock ()=0
| Unlock the polygon mesh.

## Detailed Description

This interface reprents a mesh of polygons.

It is useful to communicate geometry information outside of the engine. One place where this will be useful is for communicating geometry information to the collision detection plugin.
All Crystal Space mesh objects (things, sprites, ...) should implement and/or embed an implementation of this interface.

A polygon mesh has the concept of a vertex buffer and an array of polygons. A triangle mesh is also supported. A mesh object typically only implements either a polygon mesh or a triangle mesh. In that case requesting the other type of mesh will automatically generate the new format. iPolygonMesh can use csPolygonMeshTools::Triangulate() and csPolygonMeshTools::Polygonize() to help with that.

Main creators of instances implementing this interface:

- Almost all mesh objects have several implementations of this interface.

Main ways to get pointers to this interface:

- iObjectModel::GetPolygonMeshBase()
- iObjectModel::GetPolygonMeshColldet()
- iObjectModel::GetPolygonMeshViscull()
- iObjectModel::GetPolygonMeshShadows()

Main users of this interface:

- Collision detection plugins (iCollideSystem)
- Visibility culler plugins (iVisibilityCuller)
- Shadow stencil plugin

Definition at line 138 of file polymesh.h.

## Member Function Documentation

virtual uint32 iPolygonMesh::GetChangeNumber | ( |  | ) | const`[pure virtual]`

When this number changes you know the polygon mesh has changed (deformation has occured) since the last time you got another number from this function.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual csFlags& iPolygonMesh::GetFlags | ( |  | ) | `[pure virtual]`

Get flags for this polygon mesh.

This is zero or a combination of the following flags:

- CS_POLYMESH_CLOSED: mesh is closed.
- CS_POLYMESH_NOTCLOSED: mesh is not closed.
- CS_POLYMESH_CONVEX: mesh is convex.
- CS_POLYMESH_NOTCONVEX: mesh is not convex.
- CS_POLYMESH_DEFORMABLE: mesh is deformable.
- CS_POLYMESH_TRIANGLEMESH: mesh prefers triangle mesh.

Note that if neither CS_POLYMESH_CLOSED nor CS_POLYMESH_NOTCLOSED are set then the closed state is not known. Setting both is illegal. Note that if neither CS_POLYMESH_CONVEX nor CS_POLYMESH_NOTCONVEX are set then the convex state is not known. Setting both is illegal.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual int iPolygonMesh::GetPolygonCount | ( |  | ) | `[pure virtual]`

Get the number of polygons for this mesh.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual csMeshedPolygon* iPolygonMesh::GetPolygons | ( |  | ) | `[pure virtual]`

Get the pointer to the array of polygons.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual int iPolygonMesh::GetTriangleCount | ( |  | ) | `[pure virtual]`

Get the number of triangles for this mesh.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual csTriangle* iPolygonMesh::GetTriangles | ( |  | ) | `[pure virtual]`

Get the triangle table for this mesh.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual int iPolygonMesh::GetVertexCount | ( |  | ) | `[pure virtual]`

Get the number of vertices for this mesh.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual csVector3* iPolygonMesh::GetVertices | ( |  | ) | `[pure virtual]`

Get the pointer to the array of vertices.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual void iPolygonMesh::Lock | ( |  | ) | `[pure virtual]`

Lock the polygon mesh.

This prevents the polygon and triangle data from being cleaned up.

Implemented in csPolygonMesh, and csPolygonMeshBox.

virtual void iPolygonMesh::Unlock | ( |  | ) | `[pure virtual]`

Unlock the polygon mesh.

This allows clean up again.

Implemented in csPolygonMesh, and csPolygonMeshBox.

The documentation for this struct was generated from the following file:

- igeom/polymesh.h